"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$literal = exports.lNumber = exports.lBoolean = exports.lUndefined = exports.lNull = void 0;
const pierrejs_1 = require("pierrejs");
const utils_1 = require("./utils");
exports.lNull = pierrejs_1.default.string('null')
    .map(() => null)
    .withName('null');
exports.lUndefined = pierrejs_1.default.string('undefined')
    .map(() => void 0)
    .withName('undefined');
exports.lBoolean = pierrejs_1.default.oneOf(pierrejs_1.default.string('true'), pierrejs_1.default.string('false'))
    .map(s => s === 'true')
    .withName('boolean');
exports.lNumber = pierrejs_1.default.regex('number', /^[+\-]?[0-9]+(\.[0-9]+)?/)
    .map(n => Number(n));
const quote = pierrejs_1.default.string('"').withName('quote');
const nonQuote = pierrejs_1.default.except(quote);
const escapedChar = pierrejs_1.default.all(pierrejs_1.default.string('\\'), pierrejs_1.default.oneOf((0, utils_1.swap)('"', '"'), (0, utils_1.swap)('\\', '\\'), (0, utils_1.swap)('n', '\n'), (0, utils_1.swap)('t', '\t'))).map((0, utils_1.atPos)(1));
const stringChar = pierrejs_1.default.oneOf(escapedChar, nonQuote);
const stringContent = pierrejs_1.default.many(stringChar).map(utils_1.join);
const lString = pierrejs_1.default.all(quote, stringContent, quote)
    .map((0, utils_1.atPos)(1))
    .withName('string');
exports.$literal = pierrejs_1.default.either(exports.lNull, exports.lUndefined, exports.lBoolean, exports.lNumber, lString)
    .map((value) => ({ type: 'LITERAL', value }))
    .withName('literal');
