"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.helpers = void 0;
const utils_1 = require("../../utils");
function append(...args) {
    return args
        .map(a => String(a))
        .join('');
}
function upper(str) {
    (0, utils_1.ensure)(typeof str === 'string', 'upper expects a string');
    return str.toUpperCase();
}
function hDefault(value, defaultValue) {
    (0, utils_1.ensure)(defaultValue !== null && typeof defaultValue !== 'undefined', 'default value cannot be null or undefined');
    return value !== null && value !== void 0 ? value : defaultValue;
}
exports.helpers = Object.assign(Object.create(null), {
    append,
    upper,
    default: hDefault,
});
