"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runPathExpression = void 0;
const utils_1 = require("../utils");
function runPathExpression(expression, context) {
    const path = expression.path.split('.');
    let ctx = context;
    for (const key of path) {
        if (ctx === null || typeof ctx !== 'object' || utils_1.UNSAFE_KEYS.has(key)) {
            // TODO track warn
            return void 0;
        }
        ctx = ctx[key];
    }
    return ctx;
}
exports.runPathExpression = runPathExpression;
